#!/bin/sh
# $Id: ligaBe.sh.in,v 2.1 2001/05/09 20:46:41 waite Exp $

# This file is part of the Eli translator construction system.
# 
# Eli is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2, or (at your option) any later
# version.
# 
# Eli is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
# 
# You should have received a copy of the GNU General Public License along
# with Eli; see the file COPYING.  If not, write to the Free Software
# Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  

PKG=$1;shift; ODIN_MeIdl=$1;shift; ODIN_back_option=$1;shift; ODIN_e68=$1;shift;
ODIN_Monitor=$1; shift;
mkdir ligaBe;

SED=$ODINCACHE/PKGS/skeleton/sed.exe

# EXEC (ligaBe.sh) (.) (:MeIdl) (:back_option) (:lido.cmpd :cpp)
#   => (:ligaBe);
#     :ligaBe 'Generation of the attribute evaluator' => :DERIVED-DIRECTORY;

if true
then
 if test '' != "$ODIN_Monitor"
 then monarg="-m"
 else monarg=""
 fi
else
monarg=""
fi

# Generation of the attribute evaluator
"$ODINCACHE/PKGS/liga/ligaBe.exe" -c "$ODIN_back_option" \
			   -i "$ODIN_MeIdl" $monarg  > /dev/null 2> ERROR
if test -s core
then
   echo '".", line 0:0 DEADLY: LIGA Backend failed' >> ERROR
fi

# Processing of the error messages 
if test -s ERROR
then
   $SED -n -f "$ODINCACHE/PKGS/liga/mess_sort" ERROR
fi

if test -s ERRS
then
   echo '(|'"$ODINCACHE/PKGS/liga/Info/ligaBe.err"'|std_err|' > ERRORS
   echo '(|'"$ODIN_e68"'|line_err|' >> ERRORS
   $SED 's/^"\([^"]*\)", line \([0-9]*\):\([0-9]*\)/\1 \2 \3/' \
		ERRS >> ERRORS
   echo '|)' >> ERRORS
   echo '|)' >> ERRORS
   exit 0
fi

if test -s WARN
then
   echo '(|'"$ODINCACHE/PKGS/liga/Info/ligaBe.err"'|std_err|' > WARNINGS
   echo '(|'"$ODIN_e68"'|line_err|' >> WARNINGS
   $SED 's/^"\([^"]*\)", line \([0-9]*\):\([0-9]*\)/\1 \2 \3/' \
		WARN >> WARNINGS
   echo '|)' >> WARNINGS
   echo '|)' >> WARNINGS
fi

# Copying frames of the attribute evaluator and the tree construction module

cp "$ODINCACHE/PKGS/liga/Frames/attrpredef.h"	ligaBe
cp "$ODINCACHE/PKGS/liga/Frames/liga.head"	ligaBe
cp "$ODINCACHE/PKGS/liga/Frames/liga.init"	ligaBe

# Generated parts of the attribute evaluator and the tree construction module
mv visitprocs*.[ch]	ligaBe
mv visitmap.[ch]	ligaBe
mv node.h		ligaBe
mv treeact.h		ligaBe
mv nodecode.[ch]	ligaBe
mv treecon.[ch]		ligaBe
mv nodeptr.h            ligaBe
if test '' != "$monarg"
then
	mv attr_mon.dapto       ligaBe
fi

# Required modules
echo "$ODINCACHE/PKGS/Adt/obstack.specs" > ligaBe/treecon.reqmod
echo "$ODINCACHE/PKGS/liga/Frames/attrmain.c"   >> ligaBe/treecon.reqmod


# Monitoring support
if true
then
  if test '' != "$monarg"
  then
	mv mon_aprods.c					ligaBe
	cp "$ODINCACHE/PKGS/liga/Frames/liga.dapto"	ligaBe
  fi
fi
