#! /bin/sh
# $Id: pgsGen.sh.in,v 1.4 2004/09/09 15:13:46 profw Exp $
# Copyright (c) 1990, The Regents of the University of Colorado

# This file is part of the Eli translator construction system.

# Eli is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2, or (at your option) any later
# version.

# Eli is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

# You should have received a copy of the GNU General Public License along
# with Eli; see the file COPYING.  If not, write to the Free Software
# Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

# EXEC (pgsGen.sh) (:Pgram) (:BuPgram) (+monitor)
#      (eingabe.exe) (analyse.exe) (pgs_optim.exe) (buildtab.exe)
#      (StructConn) (parser.c) (pgs.dapto)
#   => (:pgsGen);

ODIN_Pgram=$1;shift; ODIN_BuPgram=$1;shift; ODIN_monitor=$1;shift;
ODIN_eingabe=$1;shift; ODIN_analyse=$1;shift; ODIN_pgs_optim=$1;shift;
ODIN_buildtab=$1;shift;
ODIN_StructConn=$1;shift; ODIN_parser=$1;shift; ODIN_dapto=$1;shift;
mkdir pgsGen;

SED=$ODINCACHE/PKGS/skeleton/sed.exe

if test '' = "$ODIN_monitor"
then echo 'AOUZ' > Optionen
else echo 'ACOUZ' > Optionen
fi

if test -s "$ODIN_BuPgram"
then
  input=$ODIN_BuPgram
  cp $ODIN_BuPgram Eindat
else
  input=$ODIN_Pgram
  cp $ODIN_Pgram Eindat
fi

echo NONAME | cat Optionen - | $ODIN_eingabe

$SED -e '/^#$/d
  /\* Error/s;^ *\([0-9]*\).*\*;'"$input"' 0 0;' Fehlerda \
  > ERRORS
if test -s ERRORS
then exit 0
fi

mv Putout eingabe.out

if $ODIN_analyse
then
  $SED -n -e '/\* Error /s;^[^:]*:;'"$input"' 0 0;w ERRORS' Putout
  if test -s ERRORS
  then exit 0
  fi
else
  mv Putout analyse.out

  if test -s "$ODIN_BuPgram"
  then
    # Check to see if the non-bottomup version is also not LALR(1)
    rm -f Eindat
    cp $ODIN_Pgram Eindat
    echo NONAME | cat Optionen - | $ODIN_eingabe
    if $ODIN_analyse
    then
      echo ". 0 0 You have bottomup constraints in your attribute grammar that cause your concrete syntax to not be parsable." >> ERRORS
    else
      echo "$input 0 0 Grammar is not LALR(1)" >> ERRORS
    fi
  else
    echo "$input 0 0 Grammar is not LALR(1)" >> ERRORS
  fi
  exit 0
fi

mv Produdat Produein
mv Varanada Interdat

cat Optionen | \
  ($ODIN_pgs_optim || echo 'Optimization failed') \
  >> ERRORS
if test -s ERRORS
then
  if test -s Putout; then cat Putout >> ERRORS; fi
  exit 0
fi

$ODIN_buildtab Zerdat pgs.mak.table Zudat

cat Zudat pgs.mak.table | $SED -e '/&MACRO/d' > pgsGen/pgs_gen.h
cat $ODIN_StructConn Strukdat > pgsGen/pgs_gen.c
echo "}" >> pgsGen/pgs_gen.c
echo $ODIN_parser > pgsGen/pgs.reqmod

if true
then
  if test '' != "$ODIN_monitor"
  then
  cp $ODIN_dapto pgsGen/pgs.dapto
  echo $ODINCACHE/PKGS/parser/mon_cprods.c >> pgsGen/pgs.reqmod
  cp mon_cprods.h pgsGen/mon_cprods.h
  fi
fi
